#!/bin/bash


installdir=`dirname $0`
cd $installdir

echo

if [ -z "$CATALINA_HOME" ]
then
        echo
        echo "Installation requires the CATALINA_HOME environment variable to be set to the location of your Tomcat installation. Please set the environment variable and run install.sh again."
	echo "Please read carefully the install instructions ( ./doc/INSTALL.txt )"
        exit
fi


if [ ! -f "$CATALINA_HOME/server/lib/catalina.jar" ]
then
        echo
        echo "This does not appear to be a valid Tomcat installation."
	echo "Please verify your tomcat installation and your CATALINA_HOME environment variable."
        exit
fi


if [ ! -d $CATALINA_HOME/bpr ]
then
        echo
        echo CooWS engine requires a working installation of the activeBPEL engine on $CATALINA_HOME
	echo "Please read carefully the install instructions ( ./doc/INSTALL.txt )"
        exit
fi


if [ ! -d $CATALINA_HOME/webapps/juddi ]
then
        echo
        echo CooWS engine requires a working installation of juddi on $CATALINA_HOME/webapps
	echo "Please read carefully the install instructions ( ./doc/INSTALL.txt )"
        exit
fi



echo "Copying Library..."
if  [ -f "dist/coows.jar" ]
then
	cp -rf dist/coows.jar "$CATALINA_HOME"/shared/lib > /dev/null
else
	echo
	echo "ERROR! Missing coows.jar lib!!!"
	echo "Build it with the \"ant dist\" command"
	exit
fi

rm -fr "$CATALINA_HOME"/webapps/cooengine*	
echo "Copying Webapps ..."
cp -rf dist/*.war "$CATALINA_HOME"/webapps 2> /dev/null

echo "Copying Web Services and processes ..."
cp -rf dist/*wsr dist/*bpr "$CATALINA_HOME"/bpr 2> /dev/null

echo "Copying Configuration file..."
cp -rf conf/cooEngineConf.xml "$CATALINA_HOME"/conf  > /dev/null

echo
echo "Congratulations, you have just installed CooWS!"
