package org.coows;

/**
 * Base class for the Access Specifier implementations
 */
abstract public class CooAbstractAccessSpecifier 
	implements ICooAccessSpecifier	{
	
	/** Constant: one value among {"PRIVATE", "PUBLIC", "ONLY_TRUSTED"}  */
	private final String mAccessSpecifier;


	/**
	 * Constructor
	 * 
	 * @param aAccSpec
	 */
	public CooAbstractAccessSpecifier(String aAccSpec) {
		mAccessSpecifier = aAccSpec;
	}

    /**
     * Modifier 
     * @return may be "PUBLIC" OR "PRIVATE" OR "ONLY_TRUSTED"
     * 
     * @uml.property name="mAccessSpecifier"
     */
    public String getMAccessSpecifier() {
        return mAccessSpecifier;
    }

	/**
	 * Check if an agent is trusted
	 * @param anAgentID
	 * @return
	 */
	public abstract boolean isTrusted(String anAgentID);
}
