package org.coows;

/**
 * Singleton class for the PRIVATE access specifier
 */
public class CooAccessSpecifierPrivate
    extends CooAbstractAccessSpecifier {

    /**
     * 
     * @uml.property name="mInstance"
     * @uml.associationEnd multiplicity="(0 1)"
     */
    private static final CooAccessSpecifierPrivate mInstance = new CooAccessSpecifierPrivate();

    /**
     * Constructor
     * 
     * @param aAccSpec
     */
    public CooAccessSpecifierPrivate() {
        super("PRIVATE");
    }

    public static CooAccessSpecifierPrivate getInstance() {
        return mInstance;
    }

    /**
     * @see org.coows.CooAbstractAccessSpecifier#isTrusted(java.lang.String)
     */
    public boolean isTrusted(String anAgentID) {
        return false;
    }
}
