package org.coows;

/**
 * Singleton class for the PUBLIC access specifier
 */
public class CooAccessSpecifierPublic
    extends CooAbstractAccessSpecifier {

    /**
     * 
     * @uml.property name="instance"
     * @uml.associationEnd multiplicity="(0 1)"
     */
    private static final CooAccessSpecifierPublic instance = new CooAccessSpecifierPublic();


    /**
     * Constructor
     * 
     * @param aAccSpec
     */
    public CooAccessSpecifierPublic() {
        super("PUBLIC");
    }

    /**
     * 
     * @uml.property name="instance"
     */
    public static CooAccessSpecifierPublic getInstance() {
        return instance;
    }

    /**
     * @see org.coows.CooAbstractAccessSpecifier#isTrusted(java.lang.String)
     */
    public boolean isTrusted(String anAgentID) {
        return true;
    }
}