package org.coows;

/**
 * Parameters used to invoke a process
 */
public class CooBpelProcessParameters {
    
    /**
     * May be useful when using remote BPEL engines 
     */
    private String mHostInvoker;
    
    /**
     * The agent "owner"
     */
	private String mAgentInvoker;

    /**
     * The intention that started the call
     */
    private String  mIntentionID;

	/**
	 * Constructor
	 */
	public CooBpelProcessParameters() {
	}

	/**
	 * Constructor
	 * @param agent
	 * @param host
	 */
	public CooBpelProcessParameters(
            String anHost, 
            String anAgent, 
            String anIntentionID) {
		this.mHostInvoker = anHost;
        this.mAgentInvoker = anAgent;
        this.mIntentionID = anIntentionID;
	}


	public void setAgentInvoker(String agentInvoker) {
		this.mAgentInvoker = agentInvoker;
	}


	public String getAgentInvoker() {
		return mAgentInvoker;
	}


	public void setHostInvoker(String hostInvoker) {
		this.mHostInvoker = hostInvoker;
	}


	public String getHostInvoker() {
		return mHostInvoker;
	}
}
