package org.coows;

/**
 * This event carries the info for the "achieve" op
 */
public class CooEventAchieve
	extends CooAbstractEvent {

    /**
     * The desire to achieve
     * 
     * @uml.property name="mDes"
     * @uml.associationEnd multiplicity="(0 1)"
     */
    private ICooDesire mDes;


    /** 
     * The intention ID wich belongs the plan
     * that generate this event
     */
	private String mIntentionID;


    /**
     * Constructor
     * @param anAgentTO
     * @param anIntentionID
     * @param aDes
     */
	public CooEventAchieve(
            String anAgentTO,
            String anIntentionID, 
            String aDes) {
		mAgentTO = anAgentTO;
		mIntentionID = anIntentionID;
		mDes = new CooDesire(aDes);
	}

    /**
     * 
     * @uml.property name="mDes"
     */
    public ICooDesire getMDes() {
        return mDes;
    }

    /**
     * 
     * @uml.property name="mDes"
     */
    public void setMDes(ICooDesire des) {
        mDes = des;
    }



	/**
	 * @see org.coows.ICooEvent#dd(org.coows.CooAgent)
	 */
	public void dd(CooAgent anAgent) {
		anAgent.onEventAchieve(this);
	}

    /**
     * 
     * @uml.property name="mIntentionID"
     */
    public String getMIntentionID() {
        return mIntentionID;
    }

    /**
     * 
     * @uml.property name="mIntentionID"
     */
    public void setMIntentionID(String intentionID) {
        mIntentionID = intentionID;
    }

    
    public String toString() {
        return "EventAchieve("+mAgentTO+","+mIntentionID+","+mDes+")";
    }
    

}
