package org.coows;

import java.util.Vector;

/**
 * The ordinary event
 */
public class CooEventOrdinary
	extends CooAbstractEvent {

    /**
     * The desires
     * 
     * @uml.property name="mDesire"
     * @uml.associationEnd multiplicity="(0 1)"
     */
    //private Vector<ICooDesire> mDesires;
    private ICooDesire mDesire;

    /**
     * List of actions to be performed when the desire is achieved
     * 
     * @uml.property name="mSuccessAction"
     * @uml.associationEnd multiplicity="(0 1)"
     */
    private ICooAction mSuccessAction;

    /**
     * List of actions to be performed when the desire isn't achieved
     * 
     * @uml.property name="mFailureAction"
     * @uml.associationEnd multiplicity="(0 1)"
     */
    private ICooAction mFailureAction;

    
    /**
     * Constructor
     * @param anAgentTO 
     */
	public CooEventOrdinary(
            String anAgentTO,
            //Vector<ICooDesire> desires,
            ICooDesire aDesire,
            ICooAction aSuccessAction,
            ICooAction aFailureAction) {
		mAgentTO = anAgentTO;
        //mDesires = desires;
        mDesire = aDesire;
        mSuccessAction = aSuccessAction;
        mFailureAction = aFailureAction;
	}


	/**
	 * @see org.coows.ICooEvent#dd(org.coows.CooAgent)
	 */
	public void dd(CooAgent anAgent) {
		anAgent.onEventOrdinary(this);
	}
    
    public String toString() {
        return "EventOrdinary("+mAgentTO+")";
    }


    /**
     * 
     * @uml.property name="mFailureAction"
     */
    public ICooAction getMFailureAction() {
        return mFailureAction;
    }

    /**
     * 
     * @uml.property name="mFailureAction"
     */
    public void setMFailureAction(ICooAction failureAction) {
        mFailureAction = failureAction;
    }

    /**
     * 
     * @uml.property name="mSuccessAction"
     */
    public ICooAction getMSuccessAction() {
        return mSuccessAction;
    }

    /**
     * 
     * @uml.property name="mSuccessAction"
     */
    public void setMSuccessAction(ICooAction successAction) {
        mSuccessAction = successAction;
    }


    public ICooDesire getMDesire() {
        return mDesire;
    }


    public void setMDesire(ICooDesire desire) {
        mDesire = desire;
    }

/*
    public Vector<ICooDesire> getMDesires() {
        return mDesires;
    }


    public void setMDesires(Vector<ICooDesire> desires) {
        mDesires = desires;
    }
*/
}
