package org.coows;

/**
 *	 The event for the dispatch of plan outcome
 */
public class CooEventPlanOutcome
	extends CooAbstractEvent {
    
    /** The intention ID wich belongs the completed plan */
	private String mIntentionID;

    /** The outcome: TRUE (successfully completed) or FALSE (failed) */
	private boolean mOutcome;


    /**
     * Constructor 
     * @param anAgentTO
     * @param anIntentionID
     * @param anOutcome
     */
	public CooEventPlanOutcome(String anAgentTO, String anIntentionID,
			boolean anOutcome) {
		mAgentTO = anAgentTO;
		mIntentionID = anIntentionID;
		mOutcome = anOutcome;
	}

    /**
     * 
     * @uml.property name="mIntentionID"
     */
    public String getMIntentionID() {
        return mIntentionID;
    }

	public boolean isSuccess() {
		return mOutcome;
	}


	/**
	 * @see org.coows.ICooEvent#dd(org.coows.CooAgent)
	 */
	public void dd(CooAgent anAgent) {
		anAgent.onEventPlanOutcome(this);
	}
    
    public String toString() {
        return "EventPlanOutcome("+mAgentTO+","+mIntentionID+","+mOutcome+")";
    }
}
