package org.coows;

import org.coows.util.CooRequestID;
import org.coows.util.CooSetOfPlans;

/**
 * The event for "provided" op
 */
public class CooEventProvided
	extends CooAbstractEvent {

    /**
     * The request ID
     * 
     * @uml.property name="mReqID"
     * @uml.associationEnd multiplicity="(0 1)"
     */
    private CooRequestID mReqID;


    /** The agent sender */
	private String mAgentFROM;

    /**
     * The set of provided plans
     * 
     * @uml.property name="mProvidedPlans"
     * @uml.associationEnd multiplicity="(0 1)"
     */
    private CooSetOfPlans mProvidedPlans;


	/**
	 * Constructor
	 *
	 */
	public CooEventProvided() {
		mAgentTO = "";
		mReqID = null;
        mAgentFROM = "";
		mProvidedPlans = new CooSetOfPlans();
	}

	/**
	 * Constructor
	 * @param anAgentFROM
	 * @param anAgentTO
	 * @param aReqID
	 * @param aSop
	 */
	public CooEventProvided(String anAgentFROM, String anAgentTO,
			CooRequestID aReqID, CooSetOfPlans aSop) {
		mReqID = aReqID;
		mAgentFROM = anAgentFROM;
		mAgentTO = anAgentTO;
		mProvidedPlans = aSop;
	}

    /**
     * 
     * @uml.property name="mAgentFROM"
     */
    public void setMAgentFROM(String agentProvider) {
        mAgentFROM = agentProvider;
    }

    /**
     * 
     * @uml.property name="mAgentFROM"
     */
    public String getMAgentFROM() {
        return mAgentFROM;
    }

    /**
     * 
     * @uml.property name="mProvidedPlans"
     */
    public void setMProvidedPlans(CooSetOfPlans providedPlans) {
        mProvidedPlans = providedPlans;
    }

    /**
     * 
     * @uml.property name="mProvidedPlans"
     */
    public CooSetOfPlans getMProvidedPlans() {
        return mProvidedPlans;
    }

    /**
     * 
     * @uml.property name="mReqID"
     */
    public void setMReqID(CooRequestID reqID) {
        mReqID = reqID;
    }

    /**
     * 
     * @uml.property name="mReqID"
     */
    public CooRequestID getMReqID() {
        return mReqID;
    }

	public String toString() {
		return "EventProvided("+mAgentFROM+","
            +mAgentTO+","+mReqID+","+mProvidedPlans+")";
	}


    /**
     * 
     * @see org.coows.ICooEvent#dd(org.coows.CooAgent)
     */
	public void dd(CooAgent anAgent) {
		anAgent.onEventProvided(this);
	}
}
