package org.coows;

import org.coows.util.CooRequestID;

/**
 * Wrapper for data used by requested op
 */
public class CooEventRequested
	extends CooAbstractEvent {
    
	/**
	 * The requestor ID
	 */
	private String mAgentFROM;

    /**
     * The request ID
     * 
     * @uml.property name="mReqID"
     * @uml.associationEnd multiplicity="(0 1)"
     */
    private CooRequestID mReqID;

    /**
     * The desire
     * 
     * @uml.property name="mDes"
     * @uml.associationEnd multiplicity="(0 1)"
     */
    private ICooDesire mDes;


	/**
	 * Constructor
	 * 
	 */
	public CooEventRequested() {
		mAgentTO = "";
		mAgentFROM = "";
		mReqID = null;
		mDes = new CooDesire();
	}


	/**
	 * Constructor
	 * 
	 * @param anAgentID
	 * @param aDes
	 */
	public CooEventRequested(String anAgentFROM, String anAgentTO,
			CooRequestID aReqID, ICooDesire aDes) {
		mAgentFROM = anAgentFROM;
		mAgentTO = anAgentTO;
		mReqID = aReqID;
		mDes = aDes;
	}

    /**
     * 
     * @uml.property name="mAgentFROM"
     */
    public String getMAgentFROM() {
        return mAgentFROM;
    }

    /**
     * 
     * @uml.property name="mAgentFROM"
     */
    public void setMAgentFROM(String agentID) {
        mAgentFROM = agentID;
    }

    /**
     * 
     * @uml.property name="mDes"
     */
    public ICooDesire getMDes() {
        return mDes;
    }



	public void setMDes(CooDesire des) {
		mDes = des;
	}

    /**
     * 
     * @uml.property name="mReqID"
     */
    public CooRequestID getMReqID() {
        return mReqID;
    }

    /**
     * 
     * @uml.property name="mReqID"
     */
    public void setMReqID(CooRequestID reqID) {
        mReqID = reqID;
    }

	public String toString() {
		return "EventRequested("+mAgentFROM+","
            +mAgentTO+","+mReqID+","+mDes+")";
	}


	/**
	 * @see org.coows.ICooEvent#dd(org.coows.CooAgent)
	 */
	public void dd(CooAgent anAgent) {
		anAgent.onEventRequested(this);
	}
}
