package org.coows;

import org.coows.engine.CooException;

/**
 * Define the interface for the BpelProcess
 * 
 */
public interface ICooBpelProcess {

	/** Get the service name of the bpel process */
	public String getServiceName();

	/**
	 * Deploy the process to the bpel engine
	 * 
	 * @throws CooException
	 */
	public void deploy() throws CooException;

    /**
     * Invoke the process using the given parameters
     * @param p the parameters (a wrapper class)
     * @throws CooException
     */
	public void invoke(CooBpelProcessParameters p) throws CooException;
    
    /**
     * Undeploys the process
     *
     */
    public void undeploy();
}
