package org.coows.aux;

import org.apache.axis.client.Call;
import org.apache.axis.client.Service;

import java.net.MalformedURLException;
import java.net.URL;

import javax.xml.rpc.ParameterMode;
import javax.xml.rpc.ServiceException;
import javax.xml.rpc.encoding.XMLType;

/**
 * 
 */
public class InvokePlan {
	public static void main(String[] args) {

		Call call;

		try {
			call = createInvokeCall();
			System.out.println("[CooBpelProcessBPR.invoke] "
					+ "call created! now invoking!");
			call.invoke(new Object[] { "agenteDiProva" });
		} catch (Exception e) {
			System.out.println("Error invoking bpel process "
					+ e.getLocalizedMessage());
		}
	}


	public static Call createInvokeCall() throws ServiceException,
			MalformedURLException {

		Call call = (Call) new Service().createCall();
		call.setTargetEndpointAddress(new URL(
				"http://localhost:4444/active-bpel/services/runPlanService"));
		call.setOperationName("runPlanOp");

		// Adding parameters to call
		call.addParameter("agentID", XMLType.XSD_STRING, ParameterMode.IN);
		call.setOperationStyle("rpc");

		return call;
	}
}
