package org.coows.test;

import junit.framework.TestCase;

import org.coows.CooAccessSpecifierPublic;
import org.coows.CooAgent;
import org.coows.CooDesire;
import org.coows.CooEventRemote;
import org.coows.CooEventRequested;
import org.coows.CooPlan;
import org.coows.engine.CooException;
import org.coows.util.CooRequestID;
import org.coows.util.CooSetOfPlans;

public class TestAgentQueue 
    extends TestCase {
        
    public TestAgentQueue(String aName)
        throws CooException {
        super (aName);
    }
    
    public void testARequested() 
        throws CooException {
        
        CooDesire aDes = new CooDesire("aTrigger");
        CooPlan aPlan = new CooPlan(
                "plan0", 
                aDes, 
                "aServiceName", 
                CooAccessSpecifierPublic.getInstance());
        
        CooSetOfPlans aSop = new CooSetOfPlans();
        aSop.addPlan(aPlan);
        
        CooAgent anAgent = new CooAgent(
                "anAgent", 
                CooAgent.ACQUISITION_STRATEGY_ADD, aSop);
        
        CooEventRequested aReq = new CooEventRequested(
                "anotherAgent",
                "anAgent", 
                new CooRequestID("anIntentionID", "anInstanceID"),
                aDes);
        
        anAgent.onEvent(aReq);
    }
}
