package org.coows.test;

import org.apache.axis.client.Call;
import org.apache.axis.client.Service;
import javax.xml.rpc.ParameterMode;


/**
 * 
 */
public class WSRunPlanTestClient
{

		public static void main(String[] args)
		{
		    try 
			{
				WSRunPlanTestClient client = new WSRunPlanTestClient();
				String result = client.run("Ciao!");
				System.out.println("Received: " + result);
		    }
		    catch (Exception e)
			{
		    	e.printStackTrace();
		    }
		}

		public WSRunPlanTestClient() throws Exception 
		{ }

		/**
		 * Creates a SOAP RPC call, calls the BPEL process Web service, and returns
		 * the result returned from the server. If an AxisFault is caught and it
		 * contains the magic fault string, we return that string instead of
		 * re-throwing the fault.
		 *
		 */
		public String run(String arg)
			throws Exception 
		{
		    // Call BPEL process Web service using RPC
		    Call call = createCall();
		    String result = null;

		    try
			{
		    	result = (String)call.invoke(  new Object[] { arg }     );
		    }
		    catch (Exception e)
			{
		    	result = "unexpected exception seen: " + e.toString();
		    }

		    return result;
		}

		/**
		 * Creates and returns an RPC SOAP call. The call's parameter values are taken
		 * from the config file.
		 *
		 * @return an RPC SOAP call
		 */
		protected Call createCall()
			throws Exception 
		{
		    Service service = new Service();
		    Call call = (Call)service.createCall();
		      
		    call.setTargetEndpointAddress(new java.net.URL("http://localhost:8080/active-bpel/services/runPlanService"));
		    call.setOperationName("runPlanOp");
		      
		    call.addParameter("agentID", org.apache.axis.Constants.XSD_STRING, ParameterMode.IN);
		    call.setReturnType(org.apache.axis.Constants.XSD_STRING);
		   
		    return call;
		}

		}
