package org.coows.util;

import java.util.Hashtable;
import java.util.Iterator;

import org.coows.CooIntention;
import org.coows.engine.CooException;

/**
 * A set of intentions
 *
 */
public class CooSetOfIntention {
    private Hashtable<String,CooIntention> mIntentions;
    
    public CooSetOfIntention() {
        mIntentions = new Hashtable<String,CooIntention>();
        (new CheckSuspended()).start();
    }
    
    public void addIntention(CooIntention anIntention) {
        mIntentions.put(anIntention.getMIntentionID(), anIntention);
    }
    
    public CooIntention getIntention(String anIntentionID)
        throws CooException {
        if (mIntentions.containsKey(anIntentionID))
            return mIntentions.get(anIntentionID);
        else
            throw new CooException("Trying to get unknown intention!");
    }
    
    private class CheckSuspended
        extends Thread {
        
        public void run() {
            Iterator i;
            
            while(true) {
                try {
                    sleep(10000);
                } catch(Exception e) {}

                for (CooIntention curr : mIntentions.values()) {
                    curr.checkSuspended();
                    if (curr.isCompleted())
                        mIntentions.remove(curr.getMIntentionID());
                }
            }
        }
       
    }
}
