package org.coows.work;

import java.util.LinkedList;

import org.coows.CooAgent;
import org.coows.CooGlobalEventsQueue;
import org.coows.ICooEvent;
import org.coows.engine.CooEngine;

public class CooWorkerDispatcher
	extends CooAbstractWorker
{

    /**
     * 
     * @uml.property name="mAgent"
     * @uml.associationEnd multiplicity="(0 1)"
     */
    /*
     * The agentID receiver
     */
    private CooAgent mAgent;

    /**
     * 
     * @uml.property name="mEvent"
     * @uml.associationEnd multiplicity="(0 1)"
     */
    /*
     * The event
     */
    private ICooEvent mEvent;

    
    public CooWorkerDispatcher()
    {
        super();
    }

	public synchronized void dispatchEvent(CooAgent anAgent, ICooEvent anEvent)
	{
        this.mAgent = anAgent;
        this.mEvent = anEvent;
        
		handle();
	}


	protected void execute()
	{
		mAgent.onEvent(mEvent);
	}

    protected LinkedList getQueuedEvents() {
        return CooEngine.getMAgentsManager()
            .getMGlobalEventsQueue().getMQueuedEvents();
    }

    protected void processNextWorkItem(ICooWorkItem w)
    {
        ICooEvent e = (ICooEvent)w;
        dispatchEvent(CooEngine.getMAgentsManager().getAgent(e.getMAgentTO()),
                            e); 
    }
}
