package org.coows.work;

import java.util.LinkedList;

import org.coows.CooAgent;
import org.coows.ICooEvent;

/**
 * This worker processes an event local to the agent through a double
 * dispatching
 */
public class CooWorkerProcessEvent
    extends CooAbstractWorker
{

    /**
     * 
     * @uml.property name="mAgent"
     * @uml.associationEnd multiplicity="(0 1)"
     */
    /*
     * The agentID receiver
     */
    private CooAgent mAgent;

    /**
     * 
     * @uml.property name="mEvent"
     * @uml.associationEnd multiplicity="(0 1)"
     */
    /*
     * The event
     */
    private ICooEvent mEvent;

	public CooWorkerProcessEvent()
	{
		super();
	}


	public synchronized void processEvent(CooAgent anAgent, ICooEvent anEvent)
	{
		this.mAgent = anAgent;
		this.mEvent = anEvent;

		handle();
	}


	protected void execute()
	{
		mEvent.dd(mAgent);
	}

	protected void processNextWorkItem(ICooWorkItem w)
	{
        processEvent(mAgent,(ICooEvent)w);
	}


    protected LinkedList getQueuedEvents() {
        return mAgent.getMEventQueue().getMQueuedEvents();
    }
}
