package org.coows.ws;

import org.coows.CooEventAchieve;
import org.coows.CooEventPlanOutcome;
import org.coows.CooEventRemote;
import org.coows.ICooBpelProcess;
import org.coows.ICooEvent;

import org.coows.engine.CooEngine;
import org.coows.engine.CooException;

/**
 * The CooWS Web Service
 */
public class CooWS {
    public void dispatchEventRemote(CooEventRemote aREvent) {
        CooEngine.getMAgentsManager().dispatchEvent(aREvent);
    }

    private void dispatchEvent(ICooEvent anEvent) {
            CooEngine.getMAgentsManager().dispatchEvent(anEvent);
    }

    public void achieve(String anAgent, String anIntentionID, String aDes) {
        dispatchEvent(new CooEventAchieve(anAgent, anIntentionID, aDes));
    }

    public void planOutcome(String anAgent, 
            String intentionID, boolean outcome) {
        dispatchEvent(new CooEventPlanOutcome(anAgent, intentionID, outcome));
    }

    public ICooBpelProcess getBPELProcess(String aServiceName)
            throws CooException {
        return CooEngine.getMProcessesManager().getProcess(aServiceName);
    }
}
